KDE 4.2 PyKDE API Reference

- KDE's Python API

# KPropertiesDialog Class Reference

`from PyKDE4.kio import *`

Inherits: KPageDialog → KDialog → QDialog → QWidget → QObject

## Detailed Description

## Signals

| applied ()
| canceled ()
| leaveModality ()
| propertiesClosed ()
| saveAs (KUrl oldUrl, KUrl newUrl)

## Methods

| __init__ (self, KFileItem item, QWidget parent=0)
| __init__ (self, KFileItemList _items, QWidget parent=0)
| __init__ (self, KUrl _url, QWidget parent=0)
| __init__ (self, KUrl _tempUrl, KUrl _currentDir, QString _defaultName, QWidget parent=0)
| __init__ (self, QString title, QWidget parent=0)
| __init__ (self, KPropertiesDialog a0)
| abortApplying (self)
| applied (self)
| canceled (self)
KUrl | currentDir (self)
QString | defaultName (self)
| insertPlugin (self, KPropertiesDialogPlugin plugin)
KFileItem | item (self)
KFileItemList | items (self)
KUrl | kurl (self)
| leaveModality (self)
| propertiesClosed (self)
| rename (self, QString _name)
| saveAs (self, KUrl oldUrl, KUrl newUrl)
| setFileNameReadOnly (self, bool ro)
| setFileSharingPage (self, QWidget page)
| showFileSharingPage (self)
| slotCancel (self)
| slotOk (self)
| updateUrl (self, KUrl _newUrl)

## Static Methods

bool | canDisplay (KFileItemList _items)
bool | showDialog (KFileItem item, QWidget parent=0, bool modal=1)
bool | showDialog (KUrl _url, QWidget parent=0, bool modal=1)
bool | showDialog (KFileItemList _items, QWidget parent=0, bool modal=1)

## Method Documentation

__init__ | ( | self, |
|  | KFileItem | item,
|  | QWidget | parent=0
| ) |  |  |

Brings up a Properties dialog, as shown above. This is the normal constructor for file-manager type applications, where you have a KFileItem instance to work with. Normally you will use this method rather than the one below.

Parameters:

  | item | file item whose properties should be displayed.
  | parent | is the parent of the dialog widget.
  | name | is the internal name.

__init__ | ( | self, |
|  | KFileItemList | _items,
|  | QWidget | parent=0
| ) |  |  |

You use this constructor for cases where you have a number of items, rather than a single item. Be careful which methods you use when passing a list of files or URLs, since some of them will only work on the first item in a list.

Parameters:

  | _items | list of file items whose properties should be displayed.
  | parent | is the parent of the dialog widget.
  | name | is the internal name.

__init__ | ( | self, |
|  | KUrl | _url,
|  | QWidget | parent=0
| ) |  |  |

Brings up a Properties dialog. Convenience constructor for non-file-manager applications, where you have a KUrl rather than a KFileItem or KFileItemList.

Parameters:

  | _url | the URL whose properties should be displayed
  | parent | is the parent of the dialog widget.
  | name | is the internal name.

IMPORTANT: This constructor, together with exec(), leads to a grave display bug (due to KIO.stat() being run before the dialog has all the necessary information). Do not use this combination for now. TODO: Check if the above is still true with Qt4. For local files with a known mimetype, simply create a KFileItem and pass it to the other constructor.

__init__ | ( | self, |
|  | KUrl | _tempUrl,
|  | KUrl | _currentDir,
|  | QString | _defaultName,
|  | QWidget | parent=0
| ) |  |  |

Creates a properties dialog for a new .desktop file (whose name is not known yet), based on a template. Special constructor for "File / New" in file-manager type applications.

Parameters:

  | _tempUrl | template used for reading only
  | _currentDir | directory where the file will be written to
  | _defaultName | something to put in the name field, like mimetype.desktop
  | parent | is the parent of the dialog widget.
  | name | is the internal name.

__init__ | ( | self, |
|  | QString | title,
|  | QWidget | parent=0
| ) |  |  |

Creates an empty properties dialog (for applications that want use a standard dialog, but for things not doable via the plugin-mechanism).

Parameters:

  | title | is the string display as the "filename" in the caption of the dialog.
  | parent | is the parent of the dialog widget.
  | name | is the internal name.
  | modal | tells the dialog whether it should be modal.

__init__ | ( | self, |
|  | KPropertiesDialog | a0
| ) |  |  |

abortApplying | ( |  | self ) |

To abort applying changes.

applied | ( |  | self ) |

This signal is emitted when the properties changes are applied (for example, with the OK button)

Signal syntax:
  `QObject.connect(source, SIGNAL("applied()"), target_slot)`

bool canDisplay | ( | KFileItemList | _items
| ) |  |  |

Determine whether there are any property pages available for the given file items.

Parameters:

  | _items | the list of items to check.

Returns:
  true if there are any property pages, otherwise false.

canceled | ( |  | self ) |

This signal is emitted when the properties changes are aborted (for example, with the Cancel button)

Signal syntax:
  `QObject.connect(source, SIGNAL("canceled()"), target_slot)`

KUrl currentDir | ( |  | self ) |

If the dialog is being built from a template, this method returns the current directory. If no template, it returns QString(). See the template form of the constructor.

Returns:
  the current directory or QString()

QString defaultName | ( |  | self ) |

If the dialog is being built from a template, this method returns the default name. If no template, it returns QString(). See the template form of the constructor.

Returns:
  the default name or QString()

insertPlugin | ( | self, |
|  | KPropertiesDialogPlugin | plugin
| ) |  |  |

Adds a "3rd party" properties plugin to the dialog. Useful for extending the properties mechanism.

To create a new plugin type, inherit from the base class KPropertiesDialogPlugin and implement all the methods. If you define a service .desktop file for your plugin, you do not need to call insertPlugin().

Parameters:

  | plugin | is a pointer to the KPropertiesDialogPlugin. The Properties dialog will do destruction for you. The KPropertiesDialogPlugin must have been created with the KPropertiesDialog as its parent.

See also:
  KPropertiesDialogPlugin

KFileItem item | ( |  | self ) |

Returns:
  the file item for which the dialog is shown

Warning: this method returns the first item of the list. This means that you should use this only if you are sure the dialog is used for a single item. Otherwise, you probably want items() instead.

KFileItemList items | ( |  | self ) |

Returns:
  the items for which the dialog is shown

KUrl kurl | ( |  | self ) |

The URL of the file that has its properties being displayed. This is only valid if the KPropertiesDialog was created/shown for one file or URL.

Returns:
  a parsed URL.

leaveModality | ( |  | self ) |

Signal syntax:
  `QObject.connect(source, SIGNAL("leaveModality()"), target_slot)`

propertiesClosed | ( |  | self ) |

This signal is emitted when the Properties Dialog is closed (for example, with OK or Cancel buttons)

Signal syntax:
  `QObject.connect(source, SIGNAL("propertiesClosed()"), target_slot)`

rename | ( | self, |
|  | QString | _name
| ) |  |  |

Renames the item to the specified name. This can only be called if the dialog applies to a single file or URL.

Parameters:

  | _name | new filename, encoded.

See also:
  FilePropsDialogPlugin.applyChanges

saveAs | ( | self, |
|  | KUrl | oldUrl,
|  | KUrl | newUrl
| ) |  |  |

Emitted before changes to oldUrl are saved as newUrl. The receiver may change newUrl to point to an alternative save location.

Signal syntax:
  `QObject.connect(source, SIGNAL("saveAs(const KUrl&, KUrl&)"), target_slot)`

setFileNameReadOnly | ( | self, |
|  | bool | ro
| ) |  |  |

Call this to make the filename lineedit readonly, to prevent the user from renaming the file.

Parameters:

  | ro | true if the lineedit should be read only

setFileSharingPage | ( | self, |
|  | QWidget | page
| ) |  |  |

Sets the file sharing page. This page is shown when calling showFileSharingPage().

Parameters:

  | page | the page to set

See also:
  showFileSharingPage

bool showDialog | ( | KFileItem | item,
|  | QWidget | parent=0,
|  | bool | modal=1
| ) |  |  |

Immediately displays a Properties dialog using constructor with the same parameters. On MS Windows, if item points to a local file, native (non modal) property dialog is displayed (@p parent and modal are ignored in this case).

Returns:
  true on successful dialog displaying (can be false on win32).

bool showDialog | ( | KUrl | _url,
|  | QWidget | parent=0,
|  | bool | modal=1
| ) |  |  |

Immediately displays a Properties dialog using constructor with the same parameters. On MS Windows, if _url points to a local file, native (non modal) property dialog is displayed (@p parent and modal are ignored in this case).

Returns:
  true on successful dialog displaying (can be false on win32).

bool showDialog | ( | KFileItemList | _items,
|  | QWidget | parent=0,
|  | bool | modal=1
| ) |  |  |

Immediately displays a Properties dialog using constructor with the same parameters. On MS Windows, if _items has one element and this element points to a local file, native (non modal) property dialog is displayed (@p parent and modal are ignored in this case).

Returns:
  true on successful dialog displaying (can be false on win32).

showFileSharingPage | ( |  | self ) |

Shows the page that was previously set by setFileSharingPage(), or does nothing if no page was set yet.

See also:
  setFileSharingPage

slotCancel | ( |  | self ) |

Called when the user presses 'Cancel'.

slotOk | ( |  | self ) |

Called when the user presses 'Ok'.

updateUrl | ( | self, |
|  | KUrl | _newUrl
| ) |  |  |

Updates the item URL (either called by rename or because a global apps/mimelnk desktop file is being saved) Can only be called if the dialog applies to a single file or URL.

Parameters:

  | _newUrl | the new URL